// 
// LipoMètre pour télémétrie Graupner Hott
// 
// Version 0.531
// Octobre 2013
//
// Auteur : www.thyzoon.fr 
//
// 2011-2013
//

//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
#include "Message.h"
#include "Tension_Lipo.h"

#define TRUE 1
#define FALSE 0

// Def LED verte carte Arduino mini pro
#define LEDPIN_PINMODE          pinMode (13, OUTPUT);
#define LEDPIN_SWITCH           PINB |= 1<<5;     //switch LEDPIN state (digital PIN 13)
#define LEDPIN_OFF              PORTB &= ~(1<<5);
#define LEDPIN_ON               PORTB |= (1<<5);

// Baudrate UART
#define SERIAL_COM_SPEED 		19200

// Seuil alarme sonore
#define SEUIL_ALARME 3.55

// Variables
static uint8_t octet1 = 0;  // reception
static uint8_t octet2 = 0;
static uint8_t nb_Lipo = 3; // Nb d'éléments accu Lipo
float  Lipo_total = 0;   // Tension totale mesurée
float  Lipo_Total_Mini = 26;   // Tension totale mini mesurée 
float lipo1 = 0.0; // Tension sur chacun des éléments
float lipo2 = 0.0;
float lipo3 = 0.0;
float lipo4 = 0.0; 
float lipo5 = 0.0; 
float lipo6 = 0.0; 
float lipo_mini = 0.0; // Valeur tension mini element
uint8_t Jauge = 0;  // Jauge carburant
uint8_t Alarme = FALSE; // Alarme tension basse
uint8_t Alarme_On = FALSE; // Alarme en marche

unsigned long temps = 0; // Gestion du temps depuis mise sous tension en ms
unsigned long temps_alarme = 0; // date de l'alarme de tension basse

// 
GMessage message;
TensionLipo tension;

// Init
void setup() {
  Serial.begin (SERIAL_COM_SPEED);  // Initialisation COM 19200 bauds pour recepteur HOTT GRxx
  tension.begin ();
  LEDPIN_PINMODE
  LEDPIN_OFF 
  
  // Init. pour certaines données  
  message.setLipo (lipo1,1);
  message.setLipo (lipo2,2);
  message.setLipo (lipo3,3);      
  message.setLipo (lipo4,4);  
  message.setLipo (lipo5,5);  
  message.setLipo (lipo6,6);  
  message.setAltitudeInMeters (0);
  message.setClimbrate (0);
  message.setClimbrate_M3 (0);
  message.setTemp (0,2);
  message.setVoltage2(Lipo_Total_Mini); 
  //message.setVERSION (123); // N° de version 
  
  nb_Lipo = tension.Detect (); // detection du nombre d'elements 2S a 6S  
  message.setTemp (nb_Lipo,1); // affichage nb element a la place de Temp1
}

// Boucle pricipale
void loop() {
  
  //
  // Reception ?
  //
  if (Serial.available() >=2) { // si données disponibles sur le port série
    octet1 = Serial.read();
    if (octet1 == 0x80) {
      octet2 = Serial.read();
      // Demande RX Module General Air =	$80 $8d 
      if (octet2 == 0x8d) {
        LEDPIN_ON	   
        delay(5); // attente 5ms

        // Mesure des tensions
        lipo1 = tension.Tension_Lipo1();  
        lipo2 = tension.Tension_Lipo2();  
        lipo3 = tension.Tension_Lipo3();  
        lipo4 = tension.Tension_Lipo4();
        lipo5 = tension.Tension_Lipo5();
        lipo6 = tension.Tension_Lipo6();
  
        // Calcul de la valeur de chaque elements
        switch (nb_Lipo){
          case 2 :
          Lipo_total = lipo2;
          lipo2 = lipo2 - lipo1;
          break;  

          case 3 :
          Lipo_total = lipo3;
          lipo3 = lipo3 - lipo2;
          lipo2 = lipo2 - lipo1;       
          message.setLipo (lipo3,3);   
          break;        

          case 4 :
          Lipo_total = lipo4;
          lipo4 = lipo4 - lipo3;
          lipo3 = lipo3 - lipo2;
          lipo2 = lipo2 - lipo1;
          message.setLipo (lipo3,3);      
          message.setLipo (lipo4,4);  
          break;  
        
          case 5 :
          Lipo_total = lipo5;
          lipo5 = lipo5 - lipo4;
          lipo4 = lipo4 - lipo3;
          lipo3 = lipo3 - lipo2;
          lipo2 = lipo2 - lipo1;
          message.setLipo (lipo3,3);    
          message.setLipo (lipo4,4);      
          message.setLipo (lipo5,5);  
          break;          
        
          case 6 :
          Lipo_total = lipo6;
          lipo6 = lipo6 - lipo5;
          lipo5 = lipo5 - lipo4;
          lipo4 = lipo4 - lipo3;
          lipo3 = lipo3 - lipo2;
          lipo2 = lipo2 - lipo1;
          message.setLipo (lipo3,3);    
          message.setLipo (lipo4,4);      
          message.setLipo (lipo5,5);  
          message.setLipo (lipo6,6);  
          break;         
        
          default : ;
        }     
         
        // par défaut 1 et 2      
        message.setLipo (lipo1,1);
        message.setLipo (lipo2,2);

        message.setVoltage1(Lipo_total);    // Affichage sur Batt 1
        message.setMainVoltage(Lipo_total); // Affichage sur principal
            
        if (Lipo_total < Lipo_Total_Mini)  {
          Lipo_Total_Mini = Lipo_total; // mémorise la valeur mini
          message.setVoltage2(Lipo_Total_Mini); 
        }
       
       // 
       // Recherche element le plus faible
       // pour affichage jauge
       // et gestion alarme radio
       lipo_mini = tension.Lipo_Mini(nb_Lipo,lipo1,lipo2,lipo3,lipo4,lipo5,lipo6);
       
       if ((lipo_mini >= 3.6)&&(lipo_mini <= 4.2)){
          Jauge = 100 - (4.2 - lipo_mini) / 0.0066667  ; }          

       if ((lipo_mini < 3.6) && (lipo_mini >= 3.0)) {
              Jauge = (lipo_mini - 3.0) / 0.06 ; }
              
       if (lipo_mini < 3.0) {
              Jauge = 0;               
       }
       
       // Alarme
       if (lipo_mini < SEUIL_ALARME) {       
         Alarme = TRUE;
       }  
  
       if (Alarme_On == TRUE) {
         message.alarme (ALARME_TENSION_MINI); // Bip alarme
         temps_alarme = millis ();             // temps courant
         Alarme_On = FALSE;                    // Flag faux
          }
       else {
         message.alarme (ALARME_OFF);}          // fin d'alarme
        
        // Affichage jauge carburant
        message.setFuelPercent (Jauge);
 
        message.send();  
        //Serial.flush();
        LEDPIN_OFF
       }
     }	
  }
  
  if (Alarme == TRUE) {
    temps = millis ();
    if (temps > temps_alarme + 15000) { // 15s entre alarmes
       Alarme_On = TRUE;
    }  
  }    
  
}
